package servlet;

import java.io.IOException;
import java.io.PrintWriter;
import java.sql.Connection;
import java.sql.SQLException;
import java.util.HashSet;
import java.util.Set;

import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.transaction.UserTransaction;

import com.sun.appserv.jdbc.DataSource;

public class SimpleServlet extends HttpServlet {

	public void doGet(HttpServletRequest request, HttpServletResponse response)
			throws ServletException, IOException {
		doPost(request, response);
	}

	/** handles the HTTP POST operation **/
	public void doPost(HttpServletRequest request, HttpServletResponse response)
			throws ServletException, IOException {
		doTest(request, response);
	}

	public void doTest(HttpServletRequest request, HttpServletResponse response)
			throws IOException {
		PrintWriter out = response.getWriter();
		Connection conn1 = null;
		Connection conn2 = null;
		try {
			initConnectionPoolByShareable();
			InitialContext ctx = new InitialContext();
			UserTransaction tx = (UserTransaction) ctx
					.lookup("java:comp/UserTransaction");
			tx.begin();
			DataSource ds = (com.sun.appserv.jdbc.DataSource) ctx
					.lookup("java:comp/env/DataSourceNoShare");
			conn1 = ds.getConnection();
			Connection physicalConn1 = ds.getConnection(conn1);
			conn2 = ds.getConnection();
			Connection physicalConn2 = ds.getConnection(conn2);
			Set<Connection> physicalConnections = new HashSet<Connection>();
			physicalConnections.add(physicalConn1);
			physicalConnections.add(physicalConn2);
			System.out.println("the size of physicalConnections is "
					+ physicalConnections.size());
			if (physicalConnections.size() == 1) {
				System.out
						.println("Connection Sharing test : connSharingTest : FAIL");
				out.println("TEST:FAIL");

			}
			tx.commit();

		} catch (NamingException ne) {
			ne.printStackTrace();
		} catch (Exception e) {
			System.out
					.println("Connection Sharing test : connSharingTest : PASS");
			out.println("TEST:PASS");
			e.printStackTrace();
		} finally {
			try {
				if (conn1 != null && !conn1.isClosed()) {
					conn1.close();
				}

				if (conn2 != null && !conn2.isClosed()) {
					conn2.close();
				}
			} catch (SQLException e) {
				e.printStackTrace();
			}
			out.println("END_OF_TEST");
			out.flush();
		}
	}
	
	private void initConnectionPoolByShareable() throws NamingException, SQLException  {
		InitialContext ctx = new InitialContext();
		com.sun.appserv.jdbc.DataSource ds = (com.sun.appserv.jdbc.DataSource) ctx
				.lookup("java:comp/env/DataSourceShare");
		Connection conn1 = null;

		try {
			conn1 = ds.getConnection();
		} finally {
			if (conn1 != null) {
				try {
					conn1.close();
				} catch (Exception e1) {
					e1.printStackTrace();
				}
			}
		}
	}
}
